package com.logicbig.example;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;
import java.util.List;
import java.util.stream.Collectors;

@RestController
public class EmployeeController {
    private static final String LinkFormat =
            "<a href='http://localhost:8080/employees?page=%s&size=%s'>%s</a><br/>";
    @Autowired
    private EmployeeRepository repository;

    @GetMapping("/employees")
    public String getEmployees(Pageable pageable) {
        Page<Employee> page = repository.findAll(pageable);
        List<Employee> employees = page.getContent();
        String response = employees.stream()
                                   .map(Employee::toString)
                                   .collect(Collectors.joining("<br/>"));
        response += "<br/><br/>";
        if (page.hasPrevious()) {
            response += String.format(LinkFormat, page.getNumber() - 1, page.getSize(),
                    "Previous Page");
        }
        if (page.hasNext()) {
            response += String.format(LinkFormat, page.getNumber() + 1, page.getSize(),
                    "Next Page");
        }
        return response;
    }
}